-- Назначаем ноги  и устанавливаем их режимы
tester_temp = 2  -- здесь все ds18b20               (индекс "2", gpio4, паяемся к ноге 19)
tester_dev1 = 5  -- контроль устройства 1           (индекс "5", gpio14, паяемся к ноге 5)
tester_dev2 = 12 -- контроль устройства 2           (индекс "12", gpio10, паяемся к ноге 12)
switch_dev1 = 6  -- управление устройством 1        (индекс "6", gpio12, паяемся к ноге 6)
switch_dev2 = 7  -- управление устройством 2        (индекс "7", gpio13, паяемся к ноге 7)
-- Входы:
gpio.mode(tester_temp, gpio.INPUT)
gpio.mode(tester_dev1, gpio.INPUT)
gpio.mode(tester_dev2, gpio.INPUT)
-- Выходы
gpio.mode(switch_dev1, gpio.OUTPUT)
gpio.mode(switch_dev2, gpio.OUTPUT)
gpio.write(switch_dev1, gpio.LOW) -- состояние "выкл." по умолчанию
gpio.write(switch_dev2, gpio.LOW) -- состояние "выкл" по умолчанию
-- Объявляем переменные 
t1 = nil -- текущая температура 1
t2 = nil -- текущая температура 2
t3 = nil -- текущая температура 2
old_temp1 = -90     -- предыдущая температура 1 (-90 - временное значение для старта)
old_temp2 = -90     -- предыдущая температура 2 (-90 - временное значение для старта)
old_temp3 = -90     -- предыдущая температура 3 (-90 - временное значение для старта)
current_dev1 = nil  -- текущее состояние устройства 1
current_dev2 = nil  -- текущее состояние устройства 2
old_dev1 = nil      -- предыдущее состояние устройства 1
old_dev2 = nil      -- предыдущее состояние устройства 1
delta_t = 0.5       -- разница в температуре, при которой будет отправка сообщения
time_sw = 200       -- время переключения импульсного реле (200 мс=0,2 сек)

Broker = "Ваш_Сайт"
port = Ваш_Порт
myClient = "Ваш_Клинт"
name = myClient
pass = "Ваш_Пароль"
publish = false -- регулируем возможность публикаций

m = mqtt.Client(myClient, 180, name, pass)
m:lwt("/lwt", myClient, 0, 0)

--###########################
--### Функция подключения ###
--###   (спасибо ИгорюК)  ###
--###########################
function connecting()
    print('Проверка (переподключение)...')
    publish = false
    function getConnect()
       if (wifi.sta.status() == 5) and (wifi.sta.getip() ~= nil) then
            print("Есть Wi-Fi!")
            m:connect(Broker, port, 0, 0,
                function(conn)
                    tmr.stop(6)
                    print("Подключено!")
                    publish = true
					-- подписка на 2 топика:
                    m:subscribe({["/Ваш топик девайса 1/command"]=0,["/Ваш топик девайса 2/command"]=1}, function(conn) 
                        print("Есть подписка!")
                     end)
            end)
        end
    end
    getConnect()
    tmr.alarm(6, 90000, 1, function()
        getConnect()
    end)
end

m:on("offline", function(con)
    connecting()
end)

--#########################################
--### Функция переключения устройства 1 ###
--#########################################
function swich_1() 
gpio.write(switch_dev1, gpio.HIGH)  -- включаем реле...
        print("вкл "..switch_dev1)
tmr.alarm(2, time_sw, 0, function() -- на время задержки "time_sw"
        gpio.write(switch_dev1, gpio.LOW)   -- ...выключаем
        print("выкл "..switch_dev1) 
if  gpio.read(tester_dev1) == 1 then -- проверяем состояние устройства 1...
        current_dev1 = "ON"
        elseif gpio.read(tester_dev1) == 0 then 
        current_dev1 = "OFF"
        end
m:publish("/Ваш топик девайса 1/state",(current_dev1),0,0) -- ...публикуем состояние устройства 1
tmr.delay(500000)   -- задержка для завершения публикации 
                    --(сделано намеренно, чтобы все процессы в модуле замерли и не мешали отправке)
tmr.start(4) -- продолжаем постоянный контроль устройств
end)
end         

--#########################################
--### Функция переключения устройства 2 ###
--#########################################
function swich_2() 
gpio.write(switch_dev2, gpio.HIGH)    -- включаем реле...
        print("вкл "..switch_dev2)
tmr.alarm(3, time_sw, 0, function() -- на 0,3 сек.    !!!!!!!!!!!!!!!!!!!!!!!
        gpio.write(switch_dev2, gpio.LOW)   -- ...выключаем
        print("выкл "..switch_dev2) 
        if  gpio.read(tester_dev2) == 1 then -- проверяем состояние устройства 2...
        current_dev2 = "ON"
        elseif gpio.read(tester_dev2) == 0 then 
        current_dev2 = "OFF"
        end
m:publish("/Ваш топик девайса 2/state",(current_dev2),0,0) -- ...публикуем состояние устройства 2
tmr.delay(500000)   -- задержка для завершения публикации 
                    --(сделано намеренно, чтобы все процессы в модуле замерли и не мешали отправке)
tmr.start(4) -- продолжаем постоянный контроль устройств
end)
end     


--#########################################
--###    Реакция на входящие команды    ###
--#########################################
m:on("message", function(conn, topic)          
    if (topic=="/Ваш топик девайса 1/command") then          -- если пришло сообщение для устройства 1
    tmr.stop(4) -- останавливаем контроль устройств
    swich_1() -- вызываем функцию переключения устройства 1
    elseif (topic=="/Ваш топик девайса 2/command") then            -- если пришло сообщение для устройства 2
    tmr.stop(4) -- останавливаем контроль устройств
    swich_2() -- вызываем функцию переключения устройства 2
    end
collectgarbage()
end)


--#####################################################
--### Функция проверки наличия напряжения в цепях   ###
--### питания устройств. Отправка сообщений         ###
--### при изменении значений (состояний).           ###
--#####################################################
function contr_dev() 

if  gpio.read(tester_dev1) == 1 then 
    current_dev1 = "ON"
elseif gpio.read(tester_dev1) == 0 then 
    current_dev1 = "OFF" 
end
    
if current_dev1 ~= old_dev1 then -- если состояние устройства 1 изменилось...
    old_dev1 = current_dev1
    m:publish("/Ваш топик девайса 1/state",(current_dev1),0,0) -- публикуем новое состояние устройства 1
    print("Состояние 1 = "..current_dev1)
end
    
if gpio.read(tester_dev2) == 1 then 
    current_dev2 = "ON"
    elseif gpio.read(tester_dev2) == 0 then 
    current_dev2 = "OFF" 
end

if current_dev2 ~= old_dev2 then -- если состояние устройства 2 изменилось...
    old_dev2 = current_dev2
    m:publish("/Ваш топик девайса 2/state",(current_dev2),0,0) -- публикуем новое состояние устройства 1
    print("Состояние 2 = "..current_dev2)
end
collectgarbage()

end

--##################################################
--### Функция проверки температуры и публикации  ###
--### при изменениях больше, чем на delta_t      ###
--##################################################
function contr_temp()
local ds18b20 = require('ds18b20')
ds18b20.setup(tester_temp)
local addres={}
addres=ds18b20.addrs()
local t1 = ds18b20.read(addres[1])
local t2 = ds18b20.read(addres[2])
local t3 = ds18b20.read(addres[3])
   if (t1 ~= 85) and (math.abs(t1 - old_temp1) > delta_t) then
        old_temp1 = t1
        m:publish("/Ваш топик температуры внутри устройства/state",t1,0,0) 
        print("Температура 1 "..t1)
    end
    
    if (t2 ~= 85) and (math.abs(t2 - old_temp2) > delta_t) then
        old_temp2 = t2
        m:publish("/Ваш топик температуры объекта 1/state",t2,0,0)
        print("Температура 2 "..t2)
    end
    
    if (t3 ~= 85) and (math.abs(t3 - old_temp3) > delta_t) then
        old_temp3 = t3
        m:publish("/Ваш топик температуры объекта 2/state",t3,0,0)
        print("Температура 3 "..t3)
    end
    ds18b20 = nil
    package.loaded["ds18b20"]=nil
    collectgarbage()
end


connecting()

tmr.alarm(1, 600000, 1, function() -- контроль температуры каждые 10 минут (600000 мс)
contr_temp() 
end)

tmr.alarm(4, 250, 1, function() -- контроль нагрузок каждые 0,25 сек.
contr_dev() 
end)
